---
title: 'Set.prototype[@@iterator]()'
slug: Web/JavaScript/Reference/Global_Objects/Set/@@iterator
tags:
  - ECMAScript 2015
  - Iterator
  - JavaScript
  - Method
  - Prototype
  - Reference
  - set
---
<div>{{JSRef}}</div>

<p>The initial value of the <strong><code>@@iterator</code></strong> property is the same function object as the initial value of the {{jsxref("Set.prototype.values()", "values")}} property.</p>

<div>{{EmbedInteractiveExample("pages/js/set-prototype-@@iterator.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>mySet</var>[Symbol.iterator]</pre>

<h3 id="Return_value">Return value</h3>

<p>The <code>Set</code> <strong>iterator</strong> function, which is the {{jsxref("Set.prototype.values()", "values()")}} function by default.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Using_iterator">Using [@@iterator]()</h3>

<pre class="brush:js notranslate">const mySet = new Set();
mySet.add('0');
mySet.add(1);
mySet.add({});

const setIter = mySet[Symbol.iterator]();

console.log(setIter.next().value); // "0"
console.log(setIter.next().value); // 1
console.log(setIter.next().value); // Object
</pre>

<h3 id="Using_iterator_with_for..of">Using [@@iterator]() with for..of</h3>

<pre class="brush:js notranslate">const mySet = new Set();
mySet.add('0');
mySet.add(1);
mySet.add({});

for (const v of mySet) {
  console.log(v);
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-set.prototype-@@iterator', 'Set.prototype[@@iterator]')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.Set.@@iterator")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Set.prototype.entries()")}}</li>
 <li>{{jsxref("Set.prototype.keys()")}}</li>
 <li>{{jsxref("Set.prototype.values()")}}</li>
</ul>
